/** @module parjs/combinators */ /** */
import { ImplicitParjser, ParjsCombinator } from "../../index";
/**
 * Applies `pre`, the source parser, and then `post`. Yields the result of
 * the source parser.
 * @param pre The parser to precede the source.
 * @param post The parser to proceed the source.
 */
export declare function between<T>(pre: ImplicitParjser<any>, post: ImplicitParjser<any>): ParjsCombinator<T, T>;
/**
 * Applies the `surrounding` parser, followed by the source parser, and then
 * another instance of `surrounding`. Yields the result of the source parser.
 * @param surrounding The parser to apply before and after the source.
 */
export declare function between<T>(surrounding: ImplicitParjser<any>): ParjsCombinator<T, T>;
