"use strict";
/**
 * @external
 */ /** */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const repeat_1 = __importDefault(require("lodash/repeat"));
/**
 * Some simple helpers for working with strings.
 */
var StringHelpers;
(function (StringHelpers) {
    /**
     * Recursively applies join to an array of arrays.
     * @param arr
     */
    function recJoin(arr) {
        if (arr instanceof Array) {
            return arr.map(x => this.recJoin(x)).join("");
        }
        else {
            return String(arr);
        }
    }
    StringHelpers.recJoin = recJoin;
})(StringHelpers = exports.StringHelpers || (exports.StringHelpers = {}));
/**
 * Helpers for working with numbers.
 */
var NumHelpers;
(function (NumHelpers) {
    /**
     * Pads an integer with characters.
     * @param n
     * @param digits
     * @param char
     */
    function padInt(n, digits, char) {
        let str = n.toString();
        if (str.length >= digits)
            return str;
        return repeat_1.default(char, digits - str.length) + str;
    }
    NumHelpers.padInt = padInt;
})(NumHelpers = exports.NumHelpers || (exports.NumHelpers = {}));

//# sourceMappingURL=helpers.js.map