/**
 * @module parjs
 */
/** */
import { Parjser } from "../parjser";
/**
 * A set of options for parsing floating point numbers.
 */
export interface FloatOptions {
    allowSign: boolean;
    allowImplicitZero: boolean;
    allowFloatingPoint: boolean;
    allowExponent: boolean;
}
/**
 * Returns a parser that will parse a single floating point number, in decimal
 * or scientific form.
 * @param options Options for parsing the floating-point number.
 */
export declare function float(options?: Partial<FloatOptions>): Parjser<number>;
