/**
 * @module parjs/trace
 */
/** */
import { Trace } from "./result";
/**
 * A set of arguments for the trace visualizer.
 */
export interface TraceVisualizerArgs {
    lineNumbers: boolean;
    linesBefore: number;
}
/**
 * A function that prints out a nice visualization of where a parser failed.
 */
export interface TraceVisualizer {
    (trace: Trace): string;
    configure(args: Partial<TraceVisualizerArgs>): TraceVisualizer;
}
/**
 * Visualizes a Parjs failure.
 */
export declare const visualizeTrace: TraceVisualizer;
